---
# Installation script written by following the instructions on:
# https://www.elastic.co/guide/en/elasticsearch/reference/8.9/rpm.html#rpm-repo

- name: Retrieve crypto policies
  ansible.builtin.command: update-crypto-policies --show
  register: crypto_policies
  changed_when: false

# Switching to Crypto Policy SHA1 is required to install successfully GPG Key of Elasticsearch RPM
- name: Change crypto policy to SHA1
  ansible.builtin.command: update-crypto-policies --set DEFAULT:SHA1
  when: crypto_policies.stdout != "DEFAULT:SHA1"
  changed_when: crypto_policies.stdout != "DEFAULT:SHA1"
  become: true

- name: Import GPG Key
  ansible.builtin.rpm_key:
    state: present
    key: https://artifacts.elastic.co/GPG-KEY-elasticsearch
  become: true

- name: Declare repository
  ansible.builtin.copy:
    src: elasticsearch.repo
    dest: /etc/yum.repos.d/elasticsearch.repo
    mode: "0644"
  become: true

- name: Install from RPM repository
  ansible.builtin.command: dnf install -y elasticsearch
  register: es_inst
  become: true
  changed_when: true

- name: Write install output to file
  ansible.builtin.copy:
    content: "{{ es_inst.stdout }}"
    dest: "{{ es_inst_log }}"
    mode: u=rw,g=,o=

- name: Extract generated password - Part 1 of 2
  ansible.builtin.set_fact:
    pwd_matches: '{{ es_inst.stdout | regex_search("The generated password.*:\s+([^ \n]+)", "\1") }}'

- name: Extract generated password - Part 2 of 2
  ansible.builtin.set_fact:
    es_pwd: "{{ pwd_matches[0] }}"

# - name: Set password of elastic user
#   ansible.builtin.command: echo -ne "y\n{{ es_pwd }}\n{{ es_pwd }}\n" | sudo /usr/share/elasticsearch/bin/elasticsearch-reset-password -u "{{ es_usr }}" -i
#   become: yes

- name: Write generated password to file
  ansible.builtin.copy:
    content: "{{ es_pwd }}"
    dest: "{{ es_pwd_file }}"
    mode: "0600"
